<template>
  <div class="mod-config">
    <el-form :inline="true" :model="dataForm" @keyup.enter.native="getDataList()">
      <el-form-item>
        <el-select
          v-model="dataForm.blonPlantform"
          clearable
          @change="pfChange"
          placeholder="请选择销售平台"
        >
          <el-option v-for="item in pfs" :key="item.id" :label="item.name" :value="item.id"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-select v-model="dataForm.store" clearable @change="storeChange" placeholder="请选择店铺">
          <el-option v-for="item in stores" :key="item.id" :label="item.name" :value="item.id"></el-option>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-popover ref="dtListPopover" placement="bottom-start" trigger="click">
          <el-tree
            :data="dtList"
            :props="dtListTreeProps"
            node-key="id"
            ref="dtTree"
            @current-change="dtListTreeCurrentChange"
            :default-expand-all="true"
            :highlight-current="true"
            :expand-on-click-node="false"
            style="width:194px"
          ></el-tree>
        </el-popover>
        <el-input
          v-model="dataForm.dtName"
          v-popover:dtListPopover
          :readonly="true"
          placeholder="点击选择所属机构"
          style="width:194px"
        ></el-input>
      </el-form-item>
      <el-form-item>
        <el-button @click="getDataList()">查询</el-button>
        <el-button v-if="isAuth('op:group:save')" type="primary" @click="addOrUpdateHandle()">新增</el-button>
        <el-button v-if="isAuth('op:group:delete')" type="danger" @click="deleteHandle()" :disabled="dataListSelections.length <= 0">批量删除</el-button>
      </el-form-item>
    </el-form>
    <el-table
      :data="dataList"
      border
      v-loading="dataListLoading"
      @selection-change="selectionChangeHandle"
      style="width: 100%;">
      <el-table-column
        type="selection"
        header-align="center"
        align="center"
        width="50">
      </el-table-column>
      <el-table-column
        prop="dtName"
        header-align="center"
        align="center"
        label="分销商名称">
      </el-table-column>
      <el-table-column
        prop="stName"
        header-align="center"
        align="center"
        label="店铺名称">
      </el-table-column>
      <el-table-column
        prop="groupName"
        header-align="center"
        align="center"
        label="分组名称">
      </el-table-column>
      <el-table-column
        fixed="right"
        header-align="center"
        align="center"
        label="操作">
        <template slot-scope="scope">
          <el-button type="text" size="small" @click="addOrUpdateHandle(scope.row.id)" v-if="isAuth('op:group:update')">修改</el-button>
          <el-button type="text" size="small" @click="viewHotel(scope.row)">酒店</el-button>
          <el-button type="text" size="small" @click="push(scope.row)" v-if="isAuth('op:group:push')">推送</el-button>
          <el-button type="text" size="small" @click="deleteHandle(scope.row.id)" v-if="isAuth('op:group:delete')">删除</el-button>
          <el-button type="text" size="small" @click="deleteHandleHtl(scope.row.id)" v-if="isAuth('op:group:htldel')">酒店删除</el-button>
          <el-button type="text" size="small" @click="deleteHandleRp(scope.row.id)" v-if="isAuth('op:group:htldel')">rp删除</el-button>
          <el-button
            type="text"
            size="small"
            v-if="scope.row.isDirect != 1"
            @click="directStart(scope.row.id)"
            >开启直连</el-button
          >
          <el-button
            type="text"
            size="small"
            v-if="scope.row.isDirect == 1"
            @click="directStop(scope.row.id)"
            >关闭直连</el-button
          >
        </template>
      </el-table-column>
    </el-table>
    <el-pagination
      @size-change="sizeChangeHandle"
      @current-change="currentChangeHandle"
      :current-page="pageIndex"
      :page-sizes="[10, 20, 50, 100]"
      :page-size="pageSize"
      :total="totalPage"
      layout="total, sizes, prev, pager, next, jumper">
    </el-pagination>
    <!-- 弹窗, 新增 / 修改 -->
    <add-or-update v-if="addOrUpdateVisible" ref="addOrUpdate" @refreshDataList="getDataList"></add-or-update>
  </div>
</template>

<script>
  import AddOrUpdate from './group-add-or-update'
  import { treeDataTranslate } from '@/utils'
  export default {
    data () {
      return {
        dataForm: {
          blonPlantform: null,
          key: '',
          dtId: '',
          store: null,
          group: null,
        },
        dts: [],
        sts: [],
        dataList: [],
        pageIndex: 1,
        pageSize: 10,
        totalPage: 0,
        dataListLoading: false,
        dataListSelections: [],
        addOrUpdateVisible: false,
        dtListTreeProps: {
          label: 'name',
          children: 'children'
        },
        pfs: [],
        stores: [],
        groups: [],
        dtList: []
      }
    },
    components: {
      AddOrUpdate
    },
    activated () {
      this.getDataList()
      this.getQuryPf()
    },
    methods: {
      // 分销商树选中
      dtListTreeCurrentChange(data, node) {
        this.dataForm.dtId = data.id
        this.dataForm.dtName = data.name
      },
      // 分销商设置当前选中节点
      dtListTreeSetCurrentNode() {
        if (this.dataForm.dtId != null) {
          this.$refs.dtTree.setCurrentKey(this.dataForm.dtId)
          this.dataForm.dtName = (this.$refs.dtTree.getCurrentNode() || {})['name']
        }
      },
      // 获取机构及销售平台下拉列表数据
      getQuryPf() {
        this.$http({
          url: this.$http.adornUrl('/op/group/dtpf'),
          method: 'get'
        }).then(({ data }) => {
          if (data && data.code === 0) {
            this.pfs = data.spfs
            if (data.dts.length > 0) {
              this.dataForm.dtId = data.dts[0].id
            }
            this.getDataList()
            this.dtList = treeDataTranslate(data.dts, 'id')
            this.$nextTick(function () {
              this.dtListTreeSetCurrentNode()
            })
          }
        })
      },
      // 选择销售平台
      pfChange(value) {
        this.getStore()
      },
      // 查询店铺信息
      getStore() {
        this.$http({
          url: this.$http.adornUrl('/op/group/store'),
          method: 'get',
          params: this.$http.adornParams({
            "dtId": this.dataForm.dtId,
            "pf": this.dataForm.blonPlantform
          })
        }).then(({ data }) => {
          if (data && data.code === 0) {
            this.stores = data.list
            this.storeChange(this.dataForm.store)
          }
        })
      },
      // 选择店铺
      storeChange(value) {
        this.getDataList()
      },
      // 推送
      push(row) {
        this.$confirm(`确定推送吗`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.$http({
            url: this.$http.adornUrl(`/op/group/push`),
            method: "get",
            params: this.$http.adornParams({
              groupId: row.id
            })
          }).then(({ data }) => {
            if (data && data.code === 0) {
              this.$message({
                message: data.msg,
                type: "success",
                duration: 1500,
                onClose: () => {
                  this.getDataList()
                }
              })
            } else {
              this.$message.error(data.msg)
            }
          })
        })
      },
      // 分组酒店详情
      viewHotel(group) {
        this.$router.push({ name: "op-htlgroup", params: { group: group } });
      },
      // 获取数据列表
      getDataList () {
        this.dataListLoading = true
        this.$http({
          url: this.$http.adornUrl('/op/group/list'),
          method: 'get',
          params: this.$http.adornParams({
            'page': this.pageIndex,
            'limit': this.pageSize,
            'key': this.dataForm.key,
            'dtId': this.dataForm.dtId,
            'storeId': this.dataForm.store
          })
        }).then(({data}) => {
          if (data && data.code === 0) {
            this.dataList = data.page.list
            this.totalPage = data.page.totalCount
          } else {
            this.dataList = []
            this.totalPage = 0
          }
          this.dataListLoading = false
        })
      },
      // 每页数
      sizeChangeHandle (val) {
        this.pageSize = val
        this.pageIndex = 1
        this.getDataList()
      },
      // 当前页
      currentChangeHandle (val) {
        this.pageIndex = val
        this.getDataList()
      },
      // 多选
      selectionChangeHandle (val) {
        this.dataListSelections = val
      },
      // 新增 / 修改
      addOrUpdateHandle (id) {
        this.addOrUpdateVisible = true
        this.$nextTick(() => {
          this.$refs.addOrUpdate.init(id, this.dataForm.dtId, this.pfs)
        })
      },
      // 删除
      deleteHandle (id) {
        this.$confirm(`确定对[id=${id}]进行[删除]操作?`, '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          this.$http({
            url: this.$http.adornUrl(`/op/group/delete/${id}`),
            method: 'get',
            params: this.$http.adornParams()
          }).then(({data}) => {
            if (data && data.code === 0) {
              this.$message({
                message: data.msg,
                type: 'success',
                duration: 1500,
                onClose: () => {
                  this.getDataList()
                }
              });
            } else {
              this.$message.error(data.msg);
            }
          })
        })
      },
      // 分组酒店删除
      deleteHandleHtl(id) {
        this.$confirm(`确定删除吗`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.$http({
            url: this.$http.adornUrl('/op/group/delhtl'),
            method: "get",
            params: this.$http.adornParams({
              groupId: id
            })
          }).then(({ data }) => {
            if (data && data.code === 0) {
              this.$message({
                message: "操作成功",
                type: "success",
                duration: 1500,
                onClose: () => {
                  this.getDataList()
                }
              })
            } else {
              this.$message.error(data.msg)
            }
          })
        })
      },
      // 分组rp删除
      deleteHandleRp(id) {
        this.$confirm(`确定删除吗`, "提示", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        }).then(() => {
          this.$http({
            url: this.$http.adornUrl('/op/group/delrp'),
            method: "get",
            params: this.$http.adornParams({
              groupId: id
            })
          }).then(({ data }) => {
            console.info(data)
            if (data && data.code === 0) {
              this.$message({
                message: "操作成功",
                type: "success",
                duration: 1500,
                onClose: () => {
                  this.getDataList()
                }
              })
            } else {
              this.$message.error(data.msg)
            }
          })
        })
      },
      // 开启分组订单直连
    directStart(id) {
      this.$confirm(`确定开启分组订单直连？`, "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        this.$http({
          url: this.$http.adornUrl(`/op/group/direct/start`),
          method: "get",
          params: this.$http.adornParams({
            'groupId': id
          }),
        }).then(({ data }) => {
          if (data && data.code === 0) {
            this.$message({
              message: data.msg,
              type: "success",
              duration: 1500,
              onClose: () => {
                this.getDataList();
              },
            });
          } else {
            this.$message.error(data.msg);
          }
        });
      });
    },

    // 关闭分组订单直连
    directStop(id) {
      this.$confirm(`确定关闭分组订单直连？`, "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      }).then(() => {
        this.$http({
          url: this.$http.adornUrl(`/op/group/direct/stop`),
          method: "get",
          params: this.$http.adornParams({
            'groupId': id
          }),
        }).then(({ data }) => {
          if (data && data.code === 0) {
            this.$message({
              message: data.msg,
              type: "success",
              duration: 1500,
              onClose: () => {
                this.getDataList();
              },
            });
          } else {
            this.$message.error(data.msg);
          }
        });
      });
    },
      
    }
  }
</script>
